> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Organization

> Creates a new organization with the specified name and settings.

`Unary` · [`Organizations`](/docs/api-reference/generated/organization/overview)

Creates a new organization with the specified name and settings.

Use this method to:

* Create a new organization for team collaboration
* Set up automatic domain-based invites for team members
* Join the organization immediately upon creation

### Examples

* Create a basic organization:

  Creates an organization with a name.

  ```yaml theme={null}
  name: "Acme Corp Engineering"
  joinOrganization: true
  ```

* Create with domain-based invites:

  Creates an organization that automatically invites users with matching email domains.

  ```yaml theme={null}
  name: "Acme Corp"
  joinOrganization: true
  inviteAccountsWithMatchingDomain: true
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.OrganizationService/CreateOrganization
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.OrganizationService/CreateOrganization" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "name": "<name>"
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.organization_pb2 as organization_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = organization_pb2.CreateOrganizationRequest(
      name="<name>",
  )
  response = ona.services.organization.create_organization(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { CreateOrganizationRequestSchema } from "@gitpod/sdk/gitpod/v1/organization_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(CreateOrganizationRequestSchema, {
      name: "<name>",
    });
    const response = await ona.services.organization.createOrganization(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.CreateOrganizationRequest{
  		Name: "<name>",
  	})
  	response, err := ona.Services.Organization.CreateOrganization(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "name": "<name>"
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.CreateOrganizationRequest`

| Field                              | Type    | Required | Description                                                                                    |
| ---------------------------------- | ------- | -------- | ---------------------------------------------------------------------------------------------- |
| `name`                             | string  | Yes      | name is the organization name Constraints: `required=true, string.min_len=3`.                  |
| `joinOrganization`                 | boolean | No       | join\_organization decides whether the Identity issuing this request joins the org on creation |
| `inviteAccountsWithMatchingDomain` | boolean | No       | Should other Accounts with the same domain be automatically invited to the organization?       |

## Response

`gitpod.v1.CreateOrganizationResponse`

| Field          | Type                                                      | Required | Description                                                                                                                |
| -------------- | --------------------------------------------------------- | -------- | -------------------------------------------------------------------------------------------------------------------------- |
| `organization` | [Organization](#type-gitpod-v1-organization)              | Yes      | organization is the created organization Constraints: `required=true`.                                                     |
| `member`       | [OrganizationMember](#type-gitpod-v1-organization-member) | No       | member is the member that joined the org on creation. Only set if specified "join\_organization" is "true" in the request. |

## Related types

<a id="type-gitpod-v1-invite-domains" />

<Accordion title="InviteDomains">
  `gitpod.v1.InviteDomains`

  | Field     | Type            | Required | Description                                                                                                                                                                                                                                                                                             |
  | --------- | --------------- | -------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
  | `domains` | array of string | No       | domains is the list of domains that are allowed to join the organization Constraints: `repeated.items.string.max_len=253, repeated.items.string.min_len=4, repeated.items.string.pattern=^(?:[a-zA-Z0-9](?:[a-zA-Z0-9-]&#123;0,61&#125;[a-zA-Z0-9])?\.)+[a-zA-Z]&#123;2,&#125;$, repeated.unique=true`. |
</Accordion>

<a id="type-gitpod-v1-organization" />

<Accordion title="Organization">
  `gitpod.v1.Organization`

  | Field           | Type                                                  | Required | Description                                                                           |
  | --------------- | ----------------------------------------------------- | -------- | ------------------------------------------------------------------------------------- |
  | `id`            | string                                                | Yes      | Constraints: `required=true, string.uuid=true`.                                       |
  | `name`          | string                                                | Yes      | Constraints: `required=true`.                                                         |
  | `createdAt`     | RFC 3339 timestamp                                    | Yes      | Constraints: `required=true`.                                                         |
  | `updatedAt`     | RFC 3339 timestamp                                    | Yes      | Constraints: `required=true`.                                                         |
  | `inviteDomains` | [InviteDomains](#type-gitpod-v1-invite-domains)       | No       |                                                                                       |
  | `tier`          | [OrganizationTier](#enum-gitpod-v1-organization-tier) | Yes      | The tier of the organization - free, enterprise or core Constraints: `required=true`. |
</Accordion>

<a id="type-gitpod-v1-organization-member" />

<Accordion title="OrganizationMember">
  `gitpod.v1.OrganizationMember`

  | Field           | Type                                                  | Required | Description                                                                                  |
  | --------------- | ----------------------------------------------------- | -------- | -------------------------------------------------------------------------------------------- |
  | `userId`        | string                                                | Yes      | Constraints: `required=true, string.uuid=true`.                                              |
  | `role`          | [OrganizationRole](#enum-gitpod-v1-organization-role) | Yes      | Constraints: `required=true`.                                                                |
  | `memberSince`   | RFC 3339 timestamp                                    | Yes      | Constraints: `required=true`.                                                                |
  | `avatarUrl`     | string                                                | No       |                                                                                              |
  | `fullName`      | string                                                | Yes      | Constraints: `required=true`.                                                                |
  | `email`         | string                                                | Yes      | Constraints: `required=true`.                                                                |
  | `status`        | [UserStatus](#enum-gitpod-v1-user-status)             | Yes      | Constraints: `required=true`.                                                                |
  | `loginProvider` | string                                                | Yes      | login\_provider is the login provider the user uses to sign in Constraints: `required=true`. |
</Accordion>

<a id="enum-gitpod-v1-organization-role" />

<Accordion title="OrganizationRole">
  | Value                           | Number | Description |
  | ------------------------------- | -----: | ----------- |
  | `ORGANIZATION_ROLE_UNSPECIFIED` |      0 |             |
  | `ORGANIZATION_ROLE_ADMIN`       |      1 |             |
  | `ORGANIZATION_ROLE_MEMBER`      |      2 |             |
</Accordion>

<a id="enum-gitpod-v1-organization-tier" />

<Accordion title="OrganizationTier">
  | Value                           | Number | Description |
  | ------------------------------- | -----: | ----------- |
  | `ORGANIZATION_TIER_UNSPECIFIED` |      0 |             |
  | `ORGANIZATION_TIER_FREE`        |      1 |             |
  | `ORGANIZATION_TIER_ENTERPRISE`  |      2 |             |
  | `ORGANIZATION_TIER_CORE`        |      3 |             |
  | `ORGANIZATION_TIER_FREE_ONA`    |      4 |             |
</Accordion>

<a id="enum-gitpod-v1-user-status" />

<Accordion title="UserStatus">
  | Value                     | Number | Description |
  | ------------------------- | -----: | ----------- |
  | `USER_STATUS_UNSPECIFIED` |      0 |             |
  | `USER_STATUS_ACTIVE`      |      1 |             |
  | `USER_STATUS_SUSPENDED`   |      2 |             |
  | `USER_STATUS_LEFT`        |      3 |             |
</Accordion>
